; Monitorprogramm fr VCS 80 (rfe 3/83) 
; aus rfe 6/83, S. 340-341 + Korektur 11/83, S. 686

; kommentiert: Volker Pohlers 08.01.2007
;
; Achtung! Das System ist recht kompakt programmiert und setzt RAM und ROM an den 
; vorgegebenen Bereichen (00xx bzw. 07xx voraus). 
; Ebenso mu die Tastaturtabelle auf einer ..00h-Adresse liegen


hi              function x,(x>>8)&255
lo              function x, x&255


	cpu	z80
	org	0
	
	ld	bc, 0505h	; Initialisierung PIO
	ld	hl, m011ch
	otir
	ld	bc, 0504h
	otir
;
	sub	a
	ld	i,a		; I:=0
	ld	sp, m07e0
	im	2
	ei
;
	ld	de, 573ch	; "Mo"
	call	loz
hz:	call	zahl
	and	07h
	add	a, lo(m0028)
	ld	l, a
	ld	h, 00h
	ld	l, (hl)
	jp	(hl)
;
m0028: 	db	lo(m0052)	; Adresse d. A+-Taste
	db	lo(m005c)      	; Adresse d. A--Taste
	db	lo(m003b)	; Adresse d. ME-Taste
	db	lo(m0062)	; Adresse d. RE-Taste
	db	lo(m00aa)	; Adresse d. GO-Taste
	db	lo(m00ba)	; Adresse d. TR-Taste
	db	lo(m00d2)	; Adresse d. ST-Taste
m002f:	db	00h 		; Adresse d. PE-Taste
;
;RST 30H
tre:	ex	af, af'
	exx
	pop	hl
	dec	hl
	ld	a,(m07fc)
	ld	(hl), a
	ld	(cumem), hl
; Taste MA
m003b:
me:	ld	hl,(cumem)
m003e: 
me2:	ld	(cuad), hl
m0041:
me3:	ld	e, (hl)
	dec	hl
	ld	d, (hl)
	ld	(cumem), de
	ld	e, lo(displ+4)
	ld	c, lo(cuad)
	call	ko4
	jp	hz

; Taste A+
m0052:	ld	hl, (cuad)
	ld	a, (cumem)
	ld	(hl), a
	inc	hl
	jr	me2

; Taste A-
m005c:	ld	hl, (cuad)
	dec	hl
	jr	me2

; Taste RE, Anzeige AF
m0062:	ex	af, af'
	push	af
	ex	af, af'
	ld	de, 7771h	; "AF"
;
ra:	call	loz
	ex	(sp), hl
	pop	af		; anzuzeigender Registerinhalt
	ld	(cumem), hl
	call	zahl
	cp	15h		; Taste TR, ST, PE?
	jp	p, rere		; zurck zum Hauptzyklus
	add	a, lo(m007f-10h); Taste A+..GO umsetzen
	ld	l, a 
	ld	h, hi(m007f)
	ld	l, (hl)
	jp	(hl)
;	
m007f: 	db 	lo(m0084)	; Anzeige BC	(Taste A+)
	db 	lo(m008c)	; Anzeige DE	(Taste A-)
	db 	lo(m0094)	; Anzeige HL	(Taste MA)
	db 	lo(m009c)	; Anzeige IX	(Taste RE)
	db 	lo(m00a3)	; Anzeige IY	(Taste GO)

; Anzeige BC
m0084:	exx
	push	bc
	exx
	ld	de, 7c59h	; "bC"
	jr	ra
; Anzeige DE
m008c:	exx
	push	de
	exx
	ld	de, 3e79h	; "dE"
	jr	ra
; Anzeige HL
m0094:	exx
	push	hl
	exx
	ld	de, 7658h	;"HL"
	jr	ra
; Anzeige IX, IY
m009c:	push	ix
	ld	de, 0676h	;"IH"
	jr	ra
m00a3:	push	iy
	ld	de, 066Eh	;"IY"
	jr	ra

; Taste GO
m00aa:	ld	de, 5d3ch	;"Go"
	call	loz
	call	zahl
	ld	hl, (cumem)
	push	hl
	ex	af, af'
	exx
	ret

; Taste TR
m00ba:	ld	de, 7830h	;"tr"
	call	loz
	call	zahl		; Haltepunktadresse
	ld	hl, (cumem)
	ld	a, (hl)
	ld	(m07fc), a
	ld	(hl), 0f7h	; Code RST 30H einfgen
				; --> beim Erreichen der Haltepunktadresse wird tre ausgefhrt. 
m00cc:
rere:	ld	hl, (cuad)
	jp	me3

; Taste ST
m00d2:	ld	hl, (cuad)
	dec	hl
	ld	a, (hl)
	ld	(m07fc), a
	ld	(hl), 0fbh	; Code EI
	di
	ld	a, 97h		; Interrupt ber B7 erlauben
	out	(4), a
	ld	a, 7fh
	out	(4), a
	push	hl
	ld	(m07fd), hl
	ex	af, af'
	exx
	ret			; Sprung zum eingefgten EI


; Interruptadressen
	org	(($+1)/2)*2	; ORG gerade Adresse
m00ec:	dw	m0170	; Anzeigeinterruptroutine
	dw	m01b8	; Schrittbetrieb
m00f0:	; hier kann PE-Routine beginnen


	org	0100h
; Tabelle f. Anzeige u. Tasten
m0100:	db	5fh, 06h, 3bh, 2fh, 66h, 6dh, 7dh, 07h	; "0","1","2","3","4","5","6","7"
	db	7fh, 6fh, 77h, 7ch, 59h, 3eh, 79h, 71h	; "8","9","A","b","C","d","E","F"
	db	10h, 10h, 10h, 10h, 08h, 08h, 00h, 80h	; A+, A-, MA, RE, GO, TR, ST, PE
	db	00h, 00h, 00h, 00h
	
; Initialisierung Port 5	
m011ch:	db	0cfh		; Bit-Mode
	db	0ffh		; alles IN
	db	lo(m00ec)	; Interruptadresse
	db	0b7h		; Interruptsteuerung EI, OR, HIGH, MASK
	db	7fh		; Interruptmaske
; Initialisierung Port 4
	db	0cfh		; Bit-Mode
	db	80h		; alles IN
	db	lo(m00ec+2)	; Interruptadresse
	db	17h		; Interruptsteuerung DI, OR, LO, MASK
	db	0ffh		; Interruptmaske

	db	00h, 00h
	
; UP konvertiere 4 Ziffern
m0128:	
ko4:	ld	b, hi(displ)	; hi(ram)
	ld	d, b
	call	kon
	call	kon
	ret
; UP Konvertiere 2 Ziffern von (BC) nach (DE)
m0132:	
kon:	ld	a, (bc)
	and	0fh		; unteres Nibble
	ld	l, a
	ld	h, hi(m0100)	; Tabelle Tastencode
	ld	a, (hl)		; Zeichencode
	ld 	(de), a
	inc	de
	ld	a, (bc)
	rrca
	rrca
	rrca
	rrca			; oberes Nibble
	and	0fh
	ld	l, a
	ld	a, (hl)		; Zeichencode
	ld	(de), a
	inc	de
	inc	bc
	ret
	
; UP Eingabe+Anzeige von Zahlen, bei FF Rcksprung
m0148:
zahl:	ld	e, lo(displ)
	ld	c, lo(cumem)
	call	ko4
m014f:	
z1:	ld	a, (m07ef)
	add	a, a
	jr	nc, z1
m0155:
z2:	ld	a, (m07ef)
	add	a, a
	jr	c, z2
	rra
	cp	10h
	ret	p ;(f0h)?
	ld	hl, cumem
	rld
	inc	l
	rld
	jr	zahl
	
	
	org	0170h
	org	(($+1)/2)*2	; ORG gerade Adresse
; Anzeigeinterruptroutine, Anzeigestelle wird abgefragt, 
; Segmentbelegung ausgegeben, gedrckte Taste wird gespeichert
; (Interruptroutine)
m0170:	push	hl
	push	bc
	push	af
	in	a, (7)
	and	07h
	ld	b, a
	add	a, 0f0h
	ld	l, a
	ld	h, hi(displ)	; hi(ram)
	ld	a, (hl)
	out	(6), a
	ld	a, b
	and	a
	jr	nz, m_nz
	ld	l, lo(m07ee)
	ld	a, (hl)
	ld	(hl), 080h	; " "
	inc	l
	ld	(hl), a
m018b:	
m_nz:	in	a, (7)
	and	70h
	cp	70h
	jr	z, ret
	rrca
	rrca
	rrca
	rrca
	add	a, 10h
	ld	l, a
	ld	h, hi(m0100)
	ld	a, (hl)
	add	a, b
	ld	(m07ee), a
m01a1:
ret:	pop	af
	pop	bc
	pop	hl
	ei
	reti
	
	
	org	01a8h
; UP Anzeige d. Zeichen in DE
m01a8:
loz:	ld	b, 06h
	ld	hl, 07f0h
m01ad:
lz:	ld	(hl), 00h
	inc	l
	djnz	lz
	ld	(hl), e
	inc	l
	ld	(hl), d
	ret
	
	org	01b8h
	org	(($+1)/2)*2	; ORG gerade Adresse
; Rckkehr vom Schrittbetrieb (Interruptroutine)
m01b8:	ex	af, af'
	exx
	ld	a, 07h
	out	(4), a
	ei
	ld	hl, (07fdh)
	ld	a, (m07fc)
	ld	(hl), a
	pop	hl
	ld	(cuad), hl
	ld	hl, rere
	push	hl
	reti
	

; Ramzellen d. Monitors
m07e0:	equ	07e0h	;07e0:		oberes Kellerende
m07ee:	equ	07eeh	;07ee:		Zwischenspeicher fr Tastencode
m07ef:	equ	07efh	;07ef:		aktueller Tastencode
displ:	equ	07f0h	;07f0-f7:	Segmentbelegung d. 8 Anzeigestellen; 1. Stelle ist 0f7f8
cumem:	equ	07f8h	;07f8:		Inhalt d. Speicheradresse
m07f9:	equ	07f9h	;07f9:		Inhalt d. Speicheradresse-1
cuad:	equ	07fah	;07fa/b:	Speicheradresse
m07fc:	equ	07fch	;07fc:		Zwischenspeicher f. EI-Zelle bei Schrittbetrieb
m07fd:	equ	07fdh	;07fd/e:	Adresse der EI-Zelle

	end
	
; Anzeige
;	 __0_
;	|    |
;	|6   |1
;	|__5_|
;	|    |
;	|4   |2
;	|__3_|
;
;  _         _         _         _    _
; | |   _   |_|  |_   |     _|  |_   |_  
; | |  |_|  | |  |_|  |_   |_|  |_   |    usw.
;                                        
; 57   3c   77   7c   59   3e   79   71  


; PIO
;	5	Kdo A
;	4	Kdo B
;	7	Daten A		- A0-A3 IN Tastatur Zeile, A4-A6 IN Tastatur Spalte, A7 IN Anzeigetakt
;	6	Daten B		- B0-B6 OUT 7-Segment A-F und Tastatur Zeile, B7 Int.leitung
